"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const octonom_1 = require("octonom");
function Timestamp(base) {
    const newClass = class extends base {
    };
    // ideally we'd use the decorators on the property as usual but
    // typescript doesn't like this yet, see
    // https://github.com/Microsoft/TypeScript/issues/7342
    octonom_1.Property.Date()(newClass.prototype, 'createdAt');
    octonom_1.Property.Date()(newClass.prototype, 'updatedAt');
    octonom_1.Hook('afterChange', ({ modelInstance, path, value }) => {
        const date = new Date();
        if (!modelInstance.createdAt) {
            modelInstance.set({ createdAt: date }, {}, false);
        }
        if ((path.length !== 1 || path[0] !== 'updatedAt') &&
            (path.length > 0 || typeof value !== 'object' || value.updatedAt === undefined)) {
            modelInstance.set({ updatedAt: date }, {}, false);
        }
    })(newClass);
    return newClass;
}
exports.Timestamp = Timestamp;
//# sourceMappingURL=timestamp.js.map